REM @ECHO OFF


REM            * * * WRAPI SINGLE COMPILE COMMAND * * *


REM This batch file invokes the API appropriate C compiler with the 
REM correct compile switches.  It is good for testing individual source
REM files.  Generally, you should use MAKE when building an application.
REM
REM The current compile mode (as set by APIMODE) determines where
REM compiler output is directed. Optimized (OPT) and debugging (DBG) 
REM compiler messages are directed to err.out.  Preprocessed output (PPO) 
REM is sent to <sourcefile>.ppo.


CALL APICHECK

IF (%APIDRV%)==()  APIERR DRV
IF (%APIAPP%)==()  APIERR APP
IF (%API%)==()     APIERR API

ECHO Compiling ( %1.c ) to %API% API...

               SET APIOUT=err.out
IF (%2)==(PPO) SET APIOUT=%1.ppo

%_CC% %_CFLAGS% %1.c > %APIOUT%

IF (%APIOUT%)==(err.out) type %APIOUT%
