; CGATE386.INC
; by Alex Shmidt

LAST_PRIVATE    equ     1
;
DESC_TYPE_MASK  equ     00001111B       ; TYPE field for system and gate descriptors

DESC_TYPE_UNUSED        equ     0       ; invalid descriptor
DESC_TYPE_286_TSS       equ     1       ; 80286 TSS descriptor
DESC_TYPE_LDT           equ     2
DESC_TYPE_BUSY_286_TSS  equ     3
DESC_TYPE_286_CALL_GATE equ     4
DESC_TYPE_TASK_GATE     equ     5
DESC_TYPE_286_INT_GATE  equ     6
DESC_TYPE_286_TRAP_GATE equ     7
DESC_TYPE_386_TSS       equ     9       ; 80386/80486 TSS
DESC_TYPE_BUSY_386_TSS  equ     11      ; 80386/80486 busy TSS
DESC_TYPE_386_CALL_GATE equ     12      ; 80386/80486 call gate
DESC_TYPE_386_INT_GATE  equ     14      ; 80386/80486 interrupt gate
DESC_TYPE_386_TRAP_GATE equ     15      ; 80386/80486 trap gate

CALLGATE_DDCOUNT_MASK   equ     1fh     ; dowrd count <=32
GATE32_RING3    equ     (D_PRES+D_DPL3+D_CTRL+DESC_TYPE_386_CALL_GATE) shl 8
GATE16_RING3    equ     (D_PRES+D_DPL3+D_CTRL+DESC_TYPE_286_CALL_GATE) shl 8
